Loading...
Searching...
No Matches
ON_Annotation2 Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_annotation2.h>`

Inheritance diagram for ON_Annotation2:

## Public Types

enum

eTextJustification {
tjUndefined = 0 , tjLeft = 1<<0 , tjCenter = 1<<1 , tjRight = 1<<2 ,
tjBottom = 1<<16 , tjMiddle = 1<<17 , tjTop = 1<<18 , tjBottomLeft = tjBottom | tjLeft ,
tjBottomCenter = tjBottom | tjCenter , tjBottomRight = tjBottom | tjRight , tjMiddleLeft = tjMiddle | tjLeft , tjMiddleCenter = tjMiddle | tjCenter ,
tjMiddleRight = tjMiddle | tjRight , tjTopLeft = tjTop | tjLeft , tjTopCenter = tjTop | tjCenter , tjTopRight = tjTop | tjRight
}

## Public Member Functions

| ON_Annotation2 ()
| ~ON_Annotation2 ()
| ON_Annotation2 (const ON_Annotation &)
ON_Annotation2 & | operator= (const ON_Annotation &)
void | Create ()
void | Destroy ()
void | EmergencyDestroy ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | Transform (const ON_Xform &xform)
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
bool | IsText () const
bool | IsLeader () const
bool | IsDimension () const
int | Index () const
void | SetIndex (int)
virtual double | NumericValue () const
void | SetHeight (double)
double | Height () const
void | SetType (ON::eAnnotationType)
ON::eAnnotationType | Type () const
void | SetPlane (const ON_Plane &)
const ON_Plane & | Plane () const
int | PointCount () const
void | SetPointCount (int count)
void | SetPoints (const ON_2dPointArray &)
const ON_2dPointArray & | Points () const
void | SetPoint (int, const ON_2dPoint &)
ON_2dPoint | Point (int) const
ON_DEPRECATED void | SetUserText (const wchar_t *text_value)
ON_DEPRECATED const ON_wString & | UserText () const
const wchar_t * | TextValue () const
void | SetTextValue (const wchar_t *text_value)
const wchar_t * | TextFormula () const
void | SetTextFormula (const wchar_t *s)
void | SetUserPositionedText (int bUserPositionedText)
bool | UserPositionedText () const
void | SetTextDisplayMode (ON::eTextDisplayMode)
ON::eTextDisplayMode | TextDisplayMode () const
ON_BOOL32 | GetECStoWCSXform (ON_Xform &) const
ON_BOOL32 | GetWCStoECSXform (ON_Xform &xform) const
void | ReservePoints (int)
virtual void | ConvertBack (ON_Annotation &target)
virtual void | SetJustification (unsigned int justification)
virtual unsigned int | Justification ()
bool | GetTextXform (ON_RECT gdi_text_rect, int gdi_height_of_I, double dimstyle_textheight, double dimstyle_textgap, ON::eTextDisplayMode dimstyle_textalignment, double dimscale, ON_3dVector cameraX, ON_3dVector cameraY, const ON_Xform *model_xform, ON_Xform &text_xform) const
bool | GetTextXform (ON_RECT gdi_text_rect, int gdi_height_of_I, double dimstyle_textheight, double dimstyle_textgap, ON::eTextDisplayMode dimstyle_textalignment, double dimscale, ON_3dVector cameraX, ON_3dVector cameraY, ON_Xform &xform) const
bool | GetTextXform (const ON_RECT gdi_text_rect, const ON_Font &font, const ON_DimStyle *dimstyle, double dimscale, const ON_Viewport *vp, const ON_Xform *model_xform, ON_Xform &text_xform) const
bool | GetTextXform (ON_RECT gdi_text_rect, const ON_Font &font, const ON_DimStyle &dimstyle, double dimscale, const ON_Viewport *vp, ON_Xform &xform) const
bool | GetTextPoint (ON_2dPoint &text_2d_point) const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const =0
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual void | Dump (ON_TextLog &) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static const wchar_t * | DefaultText ()

## Public Attributes

ON::eAnnotationType | m_type
ON::eTextDisplayMode | m_textdisplaymode
ON_Plane | m_plane
ON_2dPointArray | m_points
ON_Annotation2Text | m_usertext
bool | m_userpositionedtext
bool | m_annotative_scale
int | m_index
double | m_textheight
unsigned int | m_justification

## Detailed Description

Definition at line 264 of file opennurbs_annotation2.h.

## Member Enumeration Documentation

## eTextJustification

enum ON_Annotation2::eTextJustification

Enumerator
tjUndefined |
tjLeft |
tjCenter |
tjRight |
tjBottom |
tjMiddle |
tjTop |
tjBottomLeft |
tjBottomCenter |
tjBottomRight |
tjMiddleLeft |
tjMiddleCenter |
tjMiddleRight |
tjTopLeft |
tjTopCenter |
tjTopRight |

Definition at line 356 of file opennurbs_annotation2.h.

## Constructor & Destructor Documentation

## ON_Annotation2() [1/2]

ON_Annotation2::ON_Annotation2 | ( |  | ) |

Referenced by operator=().

## ~ON_Annotation2()

ON_Annotation2::~ON_Annotation2 | ( |  | ) |

## ON_Annotation2() [2/2]

ON_Annotation2::ON_Annotation2 | ( | const ON_Annotation & |  | ) |

## Member Function Documentation

## ConvertBack()

virtual void ON_Annotation2::ConvertBack | ( | ON_Annotation & | target | ) |

virtual

## Create()

void ON_Annotation2::Create | ( |  | ) |

## DefaultText()

const wchar_t * ON_Annotation2::DefaultText | ( |  | ) |

static

## Destroy()

void ON_Annotation2::Destroy | ( |  | ) |

## Dimension()

int ON_Annotation2::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## EmergencyDestroy()

void ON_Annotation2::EmergencyDestroy | ( |  | ) |

## EvaluatePoint()

bool ON_Annotation2::EvaluatePoint | ( | const class ON_ObjRef & | objref,
|  | ON_3dPoint & | P ) const

virtual

Reimplemented from ON_Geometry.

## GetECStoWCSXform()

ON_BOOL32 ON_Annotation2::GetECStoWCSXform | ( | ON_Xform & |  | ) | const

## GetTextPoint()

bool ON_Annotation2::GetTextPoint | ( | ON_2dPoint & | text_2d_point | ) | const

## GetTextXform() [1/4]

bool ON_Annotation2::GetTextXform | ( | const ON_RECT | gdi_text_rect,
|  | const ON_Font & | font,
|  | const ON_DimStyle * | dimstyle,
|  | double | dimscale,
|  | const ON_Viewport * | vp,
|  | const ON_Xform * | model_xform,
|  | ON_Xform & | text_xform ) const

## GetTextXform() [2/4]

bool ON_Annotation2::GetTextXform | ( | ON_RECT | gdi_text_rect,
|  | const ON_Font & | font,
|  | const ON_DimStyle & | dimstyle,
|  | double | dimscale,
|  | const ON_Viewport * | vp,
|  | ON_Xform & | xform ) const

## GetTextXform() [3/4]

bool ON_Annotation2::GetTextXform | ( | ON_RECT | gdi_text_rect,
|  | int | gdi_height_of_I,
|  | double | dimstyle_textheight,
|  | double | dimstyle_textgap,
|  | ON::eTextDisplayMode | dimstyle_textalignment,
|  | double | dimscale,
|  | ON_3dVector | cameraX,
|  | ON_3dVector | cameraY,
|  | const ON_Xform * | model_xform,
|  | ON_Xform & | text_xform ) const

## GetTextXform() [4/4]

bool ON_Annotation2::GetTextXform | ( | ON_RECT | gdi_text_rect,
|  | int | gdi_height_of_I,
|  | double | dimstyle_textheight,
|  | double | dimstyle_textgap,
|  | ON::eTextDisplayMode | dimstyle_textalignment,
|  | double | dimscale,
|  | ON_3dVector | cameraX,
|  | ON_3dVector | cameraY,
|  | ON_Xform & | xform ) const

## GetWCStoECSXform()

ON_BOOL32 ON_Annotation2::GetWCStoECSXform | ( | ON_Xform & | xform | ) | const

## Height()

double ON_Annotation2::Height | ( |  | ) | const

## Index()

int ON_Annotation2::Index | ( |  | ) | const

## IsDimension()

bool ON_Annotation2::IsDimension | ( |  | ) | const

## IsLeader()

bool ON_Annotation2::IsLeader | ( |  | ) | const

## IsText()

bool ON_Annotation2::IsText | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Annotation2::IsValid | ( | ON_TextLog * | text_log = NULL | ) | const

virtual

Implements ON_Object.

Reimplemented in ON_Leader2, ON_LinearDimension2, ON_OrdinateDimension2, ON_RadialDimension2, and ON_TextEntity2.

## Justification()

virtual unsigned int ON_Annotation2::Justification | ( |  | ) |

virtual

Reimplemented in ON_TextEntity2.

## NumericValue()

virtual double ON_Annotation2::NumericValue | ( |  | ) | const

virtual

Reimplemented in ON_AngularDimension2, ON_LinearDimension2, ON_OrdinateDimension2, and ON_RadialDimension2.

## ObjectType()

ON::object_type ON_Annotation2::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator=()

ON_Annotation2 & ON_Annotation2::operator= | ( | const ON_Annotation & |  | ) |

References ON_Annotation2().

## Plane()

const ON_Plane & ON_Annotation2::Plane | ( |  | ) | const

## Point()

ON_2dPoint ON_Annotation2::Point | ( | int |  | ) | const

## PointCount()

int ON_Annotation2::PointCount | ( |  | ) | const

## Points()

const ON_2dPointArray & ON_Annotation2::Points | ( |  | ) | const

## Read()

ON_BOOL32 ON_Annotation2::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

Reimplemented in ON_Leader2, ON_LinearDimension2, ON_OrdinateDimension2, ON_RadialDimension2, and ON_TextEntity2.

## ReservePoints()

void ON_Annotation2::ReservePoints | ( | int |  | ) |

## SetHeight()

void ON_Annotation2::SetHeight | ( | double |  | ) |

## SetIndex()

void ON_Annotation2::SetIndex | ( | int |  | ) |

## SetJustification()

virtual void ON_Annotation2::SetJustification | ( | unsigned int | justification | ) |

virtual

Reimplemented in ON_TextEntity2.

## SetPlane()

void ON_Annotation2::SetPlane | ( | const ON_Plane & |  | ) |

## SetPoint()

void ON_Annotation2::SetPoint | ( | int | ,
|  | const ON_2dPoint & | )

## SetPointCount()

void ON_Annotation2::SetPointCount | ( | int | count | ) |

## SetPoints()

void ON_Annotation2::SetPoints | ( | const ON_2dPointArray & |  | ) |

## SetTextDisplayMode()

void ON_Annotation2::SetTextDisplayMode | ( | ON::eTextDisplayMode |  | ) |

## SetTextFormula()

void ON_Annotation2::SetTextFormula | ( | const wchar_t * | s | ) |

## SetTextValue()

void ON_Annotation2::SetTextValue | ( | const wchar_t * | text_value | ) |

## SetType()

void ON_Annotation2::SetType | ( | ON::eAnnotationType |  | ) |

## SetUserPositionedText()

void ON_Annotation2::SetUserPositionedText | ( | int | bUserPositionedText | ) |

## SetUserText()

ON_DEPRECATED void ON_Annotation2::SetUserText | ( | const wchar_t * | text_value | ) |

## TextDisplayMode()

ON::eTextDisplayMode ON_Annotation2::TextDisplayMode | ( |  | ) | const

## TextFormula()

const wchar_t * ON_Annotation2::TextFormula | ( |  | ) | const

## TextValue()

const wchar_t * ON_Annotation2::TextValue | ( |  | ) | const

## Transform()

ON_BOOL32 ON_Annotation2::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Geometry.

Reimplemented in ON_Leader2, ON_LinearDimension2, ON_OrdinateDimension2, ON_RadialDimension2, and ON_TextEntity2.

## Type()

ON::eAnnotationType ON_Annotation2::Type | ( |  | ) | const

## UserPositionedText()

bool ON_Annotation2::UserPositionedText | ( |  | ) | const

## UserText()

ON_DEPRECATED const ON_wString & ON_Annotation2::UserText | ( |  | ) | const

## Write()

ON_BOOL32 ON_Annotation2::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_Leader2, ON_LinearDimension2, ON_OrdinateDimension2, ON_RadialDimension2, and ON_TextEntity2.

## Member Data Documentation

## m_annotative_scale

bool ON_Annotation2::m_annotative_scale

Definition at line 984 of file opennurbs_annotation2.h.

## m_index

int ON_Annotation2::m_index

Definition at line 992 of file opennurbs_annotation2.h.

## m_justification

unsigned int ON_Annotation2::m_justification

Definition at line 1001 of file opennurbs_annotation2.h.

## m_plane

ON_Plane ON_Annotation2::m_plane

Definition at line 945 of file opennurbs_annotation2.h.

## m_points

ON_2dPointArray ON_Annotation2::m_points

Definition at line 955 of file opennurbs_annotation2.h.

## m_textdisplaymode

ON::eTextDisplayMode ON_Annotation2::m_textdisplaymode

Definition at line 937 of file opennurbs_annotation2.h.

## m_textheight

double ON_Annotation2::m_textheight

Definition at line 997 of file opennurbs_annotation2.h.

## m_type

ON::eAnnotationType ON_Annotation2::m_type

Definition at line 930 of file opennurbs_annotation2.h.

## m_userpositionedtext

bool ON_Annotation2::m_userpositionedtext

Definition at line 976 of file opennurbs_annotation2.h.

## m_usertext

ON_Annotation2Text ON_Annotation2::m_usertext

Definition at line 972 of file opennurbs_annotation2.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_annotation2.h